/*
    (C) 1995-96 AROS - The Amiga Research OS
    $Id: vprintf.c,v 1.1.1.1 2005/03/15 15:54:40 laire Exp $

    Desc:
    Lang: english
*/
#include <proto/exec.h>
#include <dos/dos.h>
#include <aros/asmcall.h>
#include "dos_intern.h"

AROS_UFP2(void, vfp_hook,
    AROS_UFPA(UBYTE,        chr, D0),
    AROS_UFPA(struct vfp *, vfp, A3)
);

/*****************************************************************************

    NAME */
#include <proto/dos.h>

	AROS_LH2(LONG, VPrintf,

/*  SYNOPSIS */
	AROS_LHA(STRPTR, format,   D1),
	AROS_LHA(IPTR *, argarray, D2),

/*  LOCATION */
	struct DosLibrary *, DOSBase, 159, Dos)

/*  FUNCTION

    INPUTS

    RESULT

    NOTES

    EXAMPLE

    BUGS

    SEE ALSO

    INTERNALS

    HISTORY
	29-10-95    digulla automatically created from
			    dos_lib.fd and clib/dos_protos.h

*****************************************************************************/
{
    AROS_LIBFUNC_INIT
    AROS_LIBBASE_EXT_DECL(struct DosLibrary *,DOSBase)

    struct vfp vfp;
    struct Process *me = (struct Process *)FindTask(NULL);
    BPTR file = me->pr_Task.tc_Node.ln_Type == NT_PROCESS ? me->pr_COS : NULL;

    DEBUG_PRINTF(dprintf("VPrintf: fmt = \"%s\", args = $%lx, stdout = $%lx\n", format, argarray, file));

    FAILFORTASK(me, return EOF;)

    vfp.file=file;
    vfp.count=0;
    vfp.DOSBase=DOSBase;

    (void)RawDoFmt(format,argarray,
		   (VOID_FUNC)AROS_ASMSYMNAME(vfp_hook),
                   &vfp);

    /* Remove the last character (which is a NUL character) */
    /*if(vfp.count>0)
    {
	vfp.count--;
	((struct FileHandle *)BADDR(file))->fh_Pos--;
    }*/
    return vfp.count;
    AROS_LIBFUNC_EXIT
} /* VPrintf */
